// file: Empty.java
// author: CS102 S14 Class
// date: March 20, 2014
//
// This is an API for an immutable map. Unlike java.util.Map and ST in SW 3.1, 
// the get function for this map returns an Option type to deal with the case 
// where a key was not in the map.
//
public class Empty<Key, Value> implements Map<Key, Value> {
    
    public Option<Value> get(Key key) { return new None(); }
    public Map<Key, Value> put(Key key, Value value) {
        return new Binding(key, value, this);
    }
    public Map<Key, Value> remove(Key key) { return this; }
    public int size()        { return 0; }
    public boolean isEmpty() { return true; }
    public String toString() { return ""; }
}