// file: Map.java
// author: CS102 S14 Class
// date: March 20, 2014
//
// This is an API for an immutable map. Unlike java.util.Map and ST in
// SW 3.1, the get function for this map returns an Option type to
// deal with the case where a key was not in the map.  This ADT does
// not use null.
//
public interface Map<Key, Value> {
    
    public Option<Value>   get(Key key);
    public Map<Key, Value> put(Key key, Value value);
    public Map<Key, Value> remove(Key key);
    
    public int size();
    public boolean isEmpty();
    public String toString();

}